"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path = require("path");
var graphql_1 = require("graphql");
var graphql_codegen_core_1 = require("graphql-codegen-core");
function isPromise(obj) {
    return !!obj && (typeof obj === 'object' || typeof obj === 'function') && typeof obj.then === 'function';
}
function resolveSchema(schema) {
    return new Promise(function (resolve, reject) {
        if (isSchemaObject(schema)) {
            resolve(schema);
        }
        else if (isSchemaAst(schema)) {
            resolve(graphql_1.buildASTSchema(schema));
        }
        else if (isSchemaText(schema)) {
            var ast = graphql_1.parse(schema);
            resolve(graphql_1.buildASTSchema(ast));
        }
        else if (isSchemaJson(schema)) {
            resolve(graphql_1.buildClientSchema(schema.data));
        }
        else {
            reject(new Error('Unexpected schema type provided!'));
        }
    });
}
exports.schemaFromExport = function (file) {
    graphql_codegen_core_1.logger.info("Loading GraphQL schema object, text, ast, or introspection json from JavaScript ES6 export: " + file + "...");
    return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
        var fullPath, exports_1, rawExport, schema, schemaResult, e_1, e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fullPath = path.isAbsolute(file) ? file : path.resolve(process.cwd(), file);
                    if (!fs.existsSync(fullPath)) return [3 /*break*/, 14];
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 12, , 13]);
                    exports_1 = require(fullPath);
                    if (!exports_1) return [3 /*break*/, 10];
                    rawExport = exports_1.default || exports_1.schema || exports_1;
                    if (!rawExport) return [3 /*break*/, 8];
                    schema = void 0;
                    if (!isPromise(rawExport)) return [3 /*break*/, 3];
                    return [4 /*yield*/, rawExport];
                case 2:
                    schema = _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    schema = rawExport;
                    _a.label = 4;
                case 4:
                    _a.trys.push([4, 6, , 7]);
                    return [4 /*yield*/, resolveSchema(schema)];
                case 5:
                    schemaResult = _a.sent();
                    resolve(schemaResult);
                    return [3 /*break*/, 7];
                case 6:
                    e_1 = _a.sent();
                    graphql_codegen_core_1.debugLog('Unexpected exceptiom while trying to figure out the schema: ', e_1);
                    reject(new Error('Exported schema must be of type GraphQLSchema, text, AST, or introspection JSON.'));
                    return [2 /*return*/];
                case 7: return [3 /*break*/, 9];
                case 8:
                    reject(new Error("Invalid export from export file " + fullPath + ": missing default export or 'schema' export!"));
                    _a.label = 9;
                case 9: return [3 /*break*/, 11];
                case 10:
                    reject(new Error("Invalid export from export file " + fullPath + ": empty export!"));
                    _a.label = 11;
                case 11: return [3 /*break*/, 13];
                case 12:
                    e_2 = _a.sent();
                    reject(e_2);
                    return [3 /*break*/, 13];
                case 13: return [3 /*break*/, 15];
                case 14:
                    reject("Unable to locate introspection from export file: " + fullPath);
                    _a.label = 15;
                case 15: return [2 /*return*/];
            }
        });
    }); });
};
function isSchemaText(obj) {
    return typeof obj === 'string';
}
function isSchemaJson(obj) {
    var json = obj;
    return json.data !== undefined && json.data.__schema !== undefined;
}
function isSchemaObject(obj) {
    return obj instanceof graphql_1.GraphQLSchema;
}
function isSchemaAst(obj) {
    return obj.kind !== undefined;
}
//# sourceMappingURL=schema-from-export.js.map